diff --git a/Makefile b/Makefile
index e84bc313..b4668ff4 100755
--- a/Makefile
+++ b/Makefile
@@ -131,6 +131,7 @@ CCFLAGS_SO = -g -fPIC $(CFLAGS) -Os -Wall -fvisibility=hidden -I$(blddir_work)
 FLAGS_EXE = $(LDFLAGS) -I ${srcdir} -lpthread -L ${blddir}
 FLAGS_EXES = $(LDFLAGS) -I ${srcdir} ${START_GROUP} -lpthread -lssl -lcrypto ${END_GROUP} -L ${blddir}
 
+LDCONFIG ?= /sbin/ldconfig
 LDFLAGS_C = $(LDFLAGS) -shared -Wl,-init,$(MQTTCLIENT_INIT) -lpthread
 LDFLAGS_CS = $(LDFLAGS) -shared $(START_GROUP) -lpthread $(EXTRA_LIB) -lssl -lcrypto $(END_GROUP) -Wl,-init,$(MQTTCLIENT_INIT)
 LDFLAGS_A = $(LDFLAGS) -shared -Wl,-init,$(MQTTASYNC_INIT) -lpthread
@@ -238,7 +239,7 @@ install: build
 	$(INSTALL_DATA) ${INSTALL_OPTS} ${MQTTLIB_A_TARGET} $(DESTDIR)${libdir}
 	$(INSTALL_DATA) ${INSTALL_OPTS} ${MQTTLIB_AS_TARGET} $(DESTDIR)${libdir}
 	$(INSTALL_PROGRAM) ${INSTALL_OPTS} ${MQTTVERSION_TARGET} $(DESTDIR)${bindir}
-	/sbin/ldconfig $(DESTDIR)${libdir}
+	$(LDCONFIG) $(DESTDIR)${libdir}
 	ln -s lib$(MQTTLIB_C).so.${MAJOR_VERSION} $(DESTDIR)${libdir}/lib$(MQTTLIB_C).so
 	ln -s lib$(MQTTLIB_CS).so.${MAJOR_VERSION} $(DESTDIR)${libdir}/lib$(MQTTLIB_CS).so
 	ln -s lib$(MQTTLIB_A).so.${MAJOR_VERSION} $(DESTDIR)${libdir}/lib$(MQTTLIB_A).so
@@ -253,7 +254,7 @@ uninstall:
 	rm $(DESTDIR)${libdir}/lib$(MQTTLIB_A).so.${VERSION}
 	rm $(DESTDIR)${libdir}/lib$(MQTTLIB_AS).so.${VERSION}
 	rm $(DESTDIR)${bindir}/MQTTVersion
-	/sbin/ldconfig $(DESTDIR)${libdir}
+	$(LDCONFIG) $(DESTDIR)${libdir}
 	rm $(DESTDIR)${libdir}/lib$(MQTTLIB_C).so
 	rm $(DESTDIR)${libdir}/lib$(MQTTLIB_CS).so
 	rm $(DESTDIR)${libdir}/lib$(MQTTLIB_A).so
diff --git a/src/MQTTAsync.c b/src/MQTTAsync.c
index f475c27b..11a43581 100755
--- a/src/MQTTAsync.c
+++ b/src/MQTTAsync.c
@@ -1322,8 +1322,11 @@ void MQTTAsync_checkTimeouts()
 		
 		MQTTAsyncs* m = (MQTTAsyncs*)(current->content);
 		
+		/* check disconnect timeout */
+		if (m->c->connect_state == -2)
+			MQTTAsync_checkDisconnect(m, &m->disconnect);
 		/* check connect timeout */
-		if (m->c->connect_state != 0 && MQTTAsync_elapsed(m->connect.start_time) > (m->connectTimeout * 1000))
+		else if (m->c->connect_state != 0 && MQTTAsync_elapsed(m->connect.start_time) > (m->connectTimeout * 1000))
 		{
 			if (MQTTAsync_checkConn(&m->connect, m))
 			{
@@ -1356,10 +1359,6 @@ void MQTTAsync_checkTimeouts()
 			continue;
 		}
 	
-		/* check disconnect timeout */
-		if (m->c->connect_state == -2)
-			MQTTAsync_checkDisconnect(m, &m->disconnect);
-	
 		timed_out_count = 0;
 		/* check response timeouts */
 		while (ListNextElement(m->responses, &cur_response))
